'*******************************************************************************
' CAM_routines
'*******************************************************************************
' six1 01/2010  (Michael Kcher)
'*******************************************************************************
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'
'*******************************************************************************
$nocompile


'Setup Port Pins
  ' CAM-TXD       ist Cam-RXT
'  Open "comc.0:57600,8,n,1" For Output As #10
  Open "comc.0:115200,8,n,1" For Output As #10
  ' CAM-RXD       ist Cam-TXD
'  Open "comc.1:57600,8,n,1" For Input As #11
  Open "comc.1:115200,8,n,1" For Input As #11


Dim Cam_process_pic_time_counter As Word
Cam_process_pic_time_counter = 0
' take a picture every x seconds
Const Cam_process_pic_time = 60 * 5

Const Cam_preview_80x60 = &H01
Const Cam_preview_160x120 = &H03
Const Cam_jpeg = &H07
Const Cam_res_80x64 = &H01
Const Cam_res_160x128 = &H03
Const Cam_res_320x240 = &H05
Const Cam_res_640x480 = &H07
Const Cam_pic_type_snapshot = &H01
Const Cam_pic_type_previewpic = &H02
Const Cam_pic_type_jpegpreview = &H05

' *** IMPORTANT NOTE ON CAM_FRAMESIZE ***
' in manuel it's defined from 64(default) up to 512 Bytes.
' the $%&/*+'#@ damn shit doesn't work with value larger than 254!
' you can't use the value of 255, because the Value 0xFF looks like to reset the cam!!! ... for what reason ever...
' value larger than 255 results in getting three packages and than loosing control :-)
' so best value seems to be 254 because that's working man :-)
Const Cam_framesize = 254
Const Cam_payload = Cam_framesize - 6

'Light Frequency Type
'  50Hz = &H00
'  60Hz = &H01
Const Cam_light_frequency_type = &H00

Dim Cam_picturename As String * 11
Dim Cam_present As Byte

' **** other than net-io soft ****
'Const Buffer_size = Cam_framesize + &H45
'Dim Buffer(buffer_size) As Byte

Dim Cam_command_inbuf(6) As Byte At Buffer(&H37) Overlay
Dim Cam_command_1 As Byte At Buffer(&H38) Overlay
Dim Cam_command_2 As Byte At Buffer(&H39) Overlay

Dim Cam_pic_header(6) As Byte At Buffer(&H3d) Overlay
Dim Cam_header As Byte At Buffer(&H3e) Overlay
Dim Cam_pic_type As Byte At Buffer(&H3f) Overlay
Dim Cam_pic_len As Long At Buffer(&H40) Overlay
Dim Cam_pic_len1 As Byte At Buffer(&H40) Overlay
Dim Cam_pic_len2 As Byte At Buffer(&H41) Overlay
Dim Cam_pic_len3 As Byte At Buffer(&H42) Overlay


Dim Cam_picture_inbuf(cam_framesize) As Byte At Buffer(&H45) Overlay

Declare Function Cam_syn() As Byte
Declare Sub Cam_send_command(byval Cam_b1 As Byte , Byval Cam_b2 As Byte , Byval Cam_b3 As Byte , Byval Cam_b4 As Byte , Byval Cam_b5 As Byte , Byval Cam_b6 As Byte )
Declare Function Cam_send_command2(byval Cam_b1 As Byte , Byval Cam_b2 As Byte , Byval Cam_b3 As Byte , Byval Cam_b4 As Byte , Byval Cam_b5 As Byte , Byval Cam_b6 As Byte , Byval Res1 As Byte , Byval Res2 As Byte ) As Byte
Declare Sub Cam_receive_command
Declare Sub Cam_receive_header
Declare Sub Cam_reset()
Declare Function Cam_init_picture(byval Pic_size As Byte) As Byte
Declare function Cam_get_snapshot(byref Cam_picturename As String) as byte
Declare Sub Cam_get_motion
Declare Sub Cam_compute
Declare Sub Cam_initialize