'******************************************************************************
' UDP declarations (IP required)
'******************************************************************************
'*******************************************************************************
'  Pollin NET-IO Board with Atmega32 / 644 / 644P and ENC28J60
'*******************************************************************************
'
'  Copyright bascom-forum.de (C) [2009]  [DON]
'  -> http://bascom-forum.de/index.php?topic=1781.new;topicseen#new
'  Software based on Code by Ben Zijlstra and Viktor Varga
'  Weiterentwickelt von
'    Huetti,
'    Michael
'    boeserkorn
'    mr_energy
'    HansHans
'    six1, Michael Kcher
'    dabuze                            datetime
'    framuel
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile
'******************************************************************************
' Constants and Variables
'******************************************************************************
Const Udp_port_dns = &H3500                                 'reversed &H35 (53)
Const Udp_port_ntp = &H7B00                                 'reversed &H7B (123)
Const Udp_port_dhcp_remote = &H4300                         'reversed &H43 (67)
Const Udp_port_dhcp_local = &H4400                          'reversed &H44 (68)
'******************************************************************************
' UDP Frame
'******************************************************************************
Dim Udp_header_start As Byte At Buffer(35) Overlay
Dim Udp_w_src_port As Word At Buffer(35) Overlay
Dim Udp_w_dest_port As Word At Buffer(37) Overlay
Dim Udp_w_packet_length As Word At Buffer(39) Overlay
Dim Udp_w_chksum As Word At Buffer(41) Overlay
Dim Udp_data_start As Byte At Buffer(43) Overlay
'******************************************************************************
' Subroutines
'******************************************************************************
Declare Sub Udp_packet_filter
'( Aufruf aus: Ip_packet_filter
   Hier Werden Je Nach Protokoll Die Routinen
   Dns_packet_filter , Ntp_packet_filter Oder Dhcp_packet_filter Aufgerufen.
   Achtung : Es Wird Nicht Auf Die Empfnger Ip Adresse Geprft.
   D.h. Auch Broadcasts Werden "durchgereicht".
   Diese berprfung Muss Ggf. In Der Protokollspezifischen Prozedur Erfolgen.
')
Declare Sub Udp_checksum
'(
   Die Udp Prfsumme Wird Berechnet Und In Das Paket Eingefgt.
')
Declare Sub Udp_set_packet_length(byval Packlength As Word)
'(
   Die Lnge Des Udp Frames Wird Berechnet Und In Das Paket Eingefgt.
')
Declare Sub Udp_dump_header
'( Aufruf bei Bedarf
   Der Header Des Udp Frames Wird In Lesbarer Form ber Die Serielle Schnittstelle Ausgegeben.
')
'
